package com.sf.sx.day07;

import org.junit.Test;
import java.util.ArrayList;
import java.util.List;


public class Te {
    @Test
    public void t1(){
        int[] arr = {1,2,3,4,3,2,1};
        for (int left = 0,right = arr.length-1;left<right;left++,right--){
            if(arr[left] != arr[right]){
                break;
            }
        }
    }

    @Test
    public void t2(){
        new Thread(new Runnable() {
            @Override
            public void run() {
                System.out.println("线程启动");
            }
        }).start();

        //  用新特性lambda进行编写
        new Thread(() -> System.out.println("线程启动")).start();
    }

    /**
     *   匿名内部类   筛选出所有名称包含手机的商品
     */
    @Test
    public void t3(){
        List<Product> productList = findProductByCondition(Data.products, new MyPredicate() {
            @Override
            public boolean test(Product product) {
                return product.getName().contains("手机");
            }
        });
        System.out.println(productList);


        List<Product> productListByPrice = findProductByCondition(Data.products, new MyPredicate() {
            @Override
            public boolean test(Product product) {
                return product.getPrice()>1000;
            }
        });
        System.out.println(productListByPrice);
    }


    public static List<Product> findProductByCondition(List<Product> products,MyPredicate myPredicate){
          List<Product> list = new ArrayList<>();
        for (Product product : products) {
            if(myPredicate.test(product)){
                list.add(product);
            }
        }
        return list;

    }

    /**
     * 采用lambda表达式的方式
     */
    @Test
    public void t6(){
        //需求1: 筛选出所有名称包含手机的商品
        List<Product> productListByName = findProductByCondition(Data.products,
                (product) -> product.getName().contains("手机"));
        System.out.println(productListByName);

        // 需求2: 筛选出所有价格大于1000的商品
        List<Product> productListByPrice = findProductByCondition(Data.products,
                (product) -> product.getPrice()>1000);
        System.out.println(productListByPrice);
    }

}
